import os
import sys
import kraken.commands
from kraken.tools.TextUi import inputMenu
from kraken.tools.Utils import runCommand

def description(system, runtime):
    return "Allows running commands from a menu-driven system"

#
#  Execute the command
#
def execute(system, runtime):
   lst = os.listdir(kraken.commands.__path__[0])
   commands = ["CreateEntry", "AnnotateEntry", "EmbraceEntries", "GenerateHTML", "RegenerateCache"]
   othercommands = []
   for a in lst:
       if a[-3:] == ".py" and a != "__init__.py":
           othercommands.append(a[0:-3])
   othercommands.sort()
   othercommands.remove("Menu")
   othercommands.remove("ListAllCommands")
   othercommands.remove("TestKraken")
   othercommands.remove("Exit")
   for a in othercommands:
       if a not in commands:
           commands.append(a)
   commands.append("-")
   commands.append("Exit")
         
   commandname = inputMenu("Select the command to execute:", commands)
   print "Executing:" + commandname + "\n"
   runCommand(commandname, system, runtime)