from rdflib.URIRef import URIRef
from rdflib.Namespace import Namespace
from kraken.entrytypes.EntryBase import EntryBase
from kraken.entrytypes.Secondary import Secondary
from kraken.tools.UniqueIdGenerator import getUniqueId
import time
import kraken.platform.PlatformUtilities as PlatformUtilities


class Note(EntryBase, Secondary):

  def __init__(self):
      EntryBase.__init__(self)      
      self.__class__.defaultMapping = Namespace("http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/Note/")      
      self.resourceURI = URIRef("note://" + getUniqueId())
      # initialize the fields, to set the types - this is needed for the time
      self.registerProperty("text", "")

            
  #
  #  these are characteristic for the secondaries.
  #

  def loadEntryFromNative(self, filepath):
    try:
        fd = open(filepath, 'r')
        content = fd.read()
        fd.close()
    except:
        print 'Could not open file:', filepath
        return
    self.addProperty("text", content)  
    
    
def createEmpty(entry, descriptor):
    nativeFileName = descriptor.getNativeFileName(entry)
    tmp = "Title: " + entry.getProperty("title") + "\n"
    FILE = open(nativeFileName, "w+")
    FILE.write(tmp)
    FILE.close()
    note = Note()
    note.loadEntryFromNative(nativeFileName)        
    note.writeEntryToRdf(descriptor.getRdfFileName(entry))
    return entry
    
def edit(entry, descriptor):
   notefile = descriptor.getNativeFileName(entry)
   PlatformUtilities.editTextFile(notefile)
