import os
import os.path
import kraken.entrytypes.Entry as Entry
import kraken.Constants as Constants
import kraken.entrytypes.MetaData as MetaData

def getOwner(system):
      """
      Returns the owner entry
      """
      entry = Entry.loadKraEntry(system, system.getProperty("systemDir"), Constants.DIRNAME_OWNER)
      if entry == None:
         print "\n\n\nCreating empty owner record\n\n\n"
         entry = Entry.Entry()
         # fill in default owner record      
      #entry = Entry.Entry()
      return entry
      
def updateOwner(entry, system):
    """
    Save the owner record
    """
    ownerDir = os.path.join(system.getProperty("systemDir"), Constants.DIRNAME_OWNER)
    if not os.path.isdir(ownerDir):
        os.mkdir(ownerDir)
    entry.writeRDF(ownerDir)

# FIXME: more elaborate editing of the owner info      
def editOwner(entry, system):
   metadata = MetaData.loadMetaData(system) 
   entry.edit(metadata)
