from rdflib.URIRef import URIRef
from rdflib.Namespace import Namespace
from kraken.entrytypes.EntryBase import EntryBase
from kraken.entrytypes.Secondary import Secondary
from kraken.tools.UniqueIdGenerator import getUniqueId
import time


class vCard(EntryBase, Secondary):

  # the self description of the class
  namespaces = {}
  # the namespaces  
  namespaces["vCard"] = "http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/vCard/"
  VCARD = Namespace(namespaces["vCard"]);
  
  def __init__(self):
      EntryBase.__init__(self)
      self.filecontents_source = ""
      self.resourceURI = URIRef("opinion://" + getUniqueId())
      # initialize the fields, to set the types - this is needed for the time
      self.__class__.defaultMapping = self.VCARD
      #self.registerProperty("id", "")
      #self.registerProperty("ranking", 0)
      #self.registerProperty("lastVisited", time.localtime())
      #self.registerProperty("lastModified", time.localtime())
      self.registerProperty("opinionOf", "")
      #self.registerProperty("trust", 100) # perfect trust by default
      #self.registerProperty("activity", 100) # activity percentile, starts by being fully active
      
  #
  #  Command line based editing of an entry - mainly for annotation, etc
  #            
  def edit(self, metadata = None):
      print "vCard"
      self.editField("ranking", "Ranking [0-100]")
      self.editField("trust", "Trust [-100, 100]")
      self.editField("activity", "Activity [0-100]")      
      
def createEmpty(entry, descriptor):
    op = vCard()
    rdfFileName = descriptor.getRdfFileName(entry)
    op.writeEntryToRdf(rdfFileName)
    
def editVCard(entry, descriptor):
    op = descriptor.loadSecondary(entry)
    op.edit()
    rdfFileName = descriptor.getRdfFileName(entry)
    op.writeEntryToRdf(rdfFileName) 
