import os
import os.path
import logging
import WindowsUtilities
import PosixUtilities

def editTextFile(fileName):
    """
      Invokes an editor on the text file
    """
    if os.name == "posix":
        PosixUtilities.editTextFile(fileName)
    elif os.name == "nt":
        WindowsUtilities.editTextFile(fileName)
    else:
        logging.critical("editTextFile is not supported on platform " + os.name)
        
def openDirectory(dirName):
    """
      Invokes the file manager of the platform on a given directory
    """
    if os.name == "posix":
        PosixUtilities.openDirectory(dirName)
    elif os.name == "nt":
        WindowsUtilities.openDirectory(dirName)
    else:
        logging.critical("editTextFile is not supported on platform " + os.name)
        
def changeDirectory(dirName):
    """
       Changes to the given directory
    """
    os.chdir(os.path.absname(dirName))    
    

